package cn.iocoder.foodnexus.module.erp.service.sale;

import cn.iocoder.foodnexus.framework.common.pojo.PageResult;
import cn.iocoder.foodnexus.module.erp.controller.admin.sale.vo.order.*;
import cn.iocoder.foodnexus.module.erp.dal.dataobject.sale.ErpSaleOrderDO;
import cn.iocoder.foodnexus.module.erp.dal.dataobject.sale.ErpSaleOrderItemDO;
import cn.iocoder.foodnexus.module.order.dto.DeliveryOrderUpdateReqVO;
import jakarta.validation.Valid;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * ERP 销售订单 Service 接口
 *
 * @author 芋道源码
 */
public interface ErpSaleOrderService {

    String SALE_ORDER_LOCK = "saleOrderLock:%s";

    /**
     * 创建销售订单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createSaleOrder(@Valid ErpSaleOrderSaveReqVO createReqVO);

    /**
     * 更新销售订单
     *
     * @param updateReqVO 更新信息
     */
    void updateSaleOrder(@Valid ErpSaleOrderSaveReqVO updateReqVO);

    /**
     * 更新销售订单的状态
     *
     * @param id 编号
     * @param status 状态
     */
    void updateSaleOrderStatus(Long id, Integer status);

    /**
     * 更新销售订单的出库数量
     *
     * @param id 编号
     * @param outCountMap 出库数量 Map：key 销售订单项编号；value 出库数量
     */
    void updateSaleOrderOutCount(Long id, Map<Long, BigDecimal> outCountMap);

    /**
     * 更新销售订单的退货数量
     *
     * @param orderId 编号
     * @param returnCountMap 退货数量 Map：key 销售订单项编号；value 退货数量
     */
    void updateSaleOrderReturnCount(Long orderId, Map<Long, BigDecimal> returnCountMap);

    /**
     * 删除销售订单
     *
     * @param ids 编号数组
     */
    void deleteSaleOrder(List<Long> ids);

    /**
     * 获得销售订单
     *
     * @param id 编号
     * @return 销售订单
     */
    ErpSaleOrderDO getSaleOrder(Long id);

    /**
     * 校验销售订单，已经审核通过
     *
     * @param id 编号
     * @return 销售订单
     */
    ErpSaleOrderDO validateSaleOrder(Long id);

    /**
     * 获得销售订单分页
     *
     * @param pageReqVO 分页查询
     * @return 销售订单分页
     */
    PageResult<ErpSaleOrderDO> getSaleOrderPage(ErpSaleOrderPageReqVO pageReqVO);

    // ==================== 销售订单项 ====================

    /**
     * 获得销售订单项列表
     *
     * @param orderId 销售订单编号
     * @return 销售订单项列表
     */
    List<ErpSaleOrderItemDO> getSaleOrderItemListByOrderId(Long orderId);

    /**
     * 获得销售订单项 List
     *
     * @param orderIds 销售订单编号数组
     * @return 销售订单项 List
     */
    List<ErpSaleOrderItemDO> getSaleOrderItemListByOrderIds(Collection<Long> orderIds);

    /**
     * 更新销售订单配送人员
     * @param id
     * @param deliveryStaffId
     */
    boolean updateDeliveryStaff(Long id, Long deliveryStaffId);

    /**
     * 更新拣货
     * @param id
     * @param itemId
     */
    void updatePickUp(Long id, Long itemId);

    /**
     * 取货，生成销售出库单
     */
    void delivery(Long id, Long deliveryStaffId);

    /**
     * 接单
     * @param id
     * @param deliveryStaffId
     */
    void accept(Long id, Long deliveryStaffId);

    /**
     * 到货
     */
    void arrival(DeliveryOrderUpdateReqVO reqVO, Long deliveryStaffId);

    /**
     * 根据客户订单新建配货单
     * @param customerOrderId
     */
    void createByCustomerOrderId(Long customerOrderId);

    ErpSaleOrderDO queryByCustomerOrderId(Long customerOrderId);

    ErpSaleOrderItemDO queryItemByCustomerOrderItemId(Long customerOrderItemId);

    void receiptByCustomerOrderId(Long id, List<Long> customerOrderItemId);

    /**
     * "个人中心 - 配送订单数"
     */
    DeliveryMyCountRespVO queryMyCount(Long userId);

    /**
     * "接单大厅 - 配送状态订单数统计"
     */
    List<DeliveryStatusCountRespVO> statusCount(Long userId, Set<Long> deptIds);

    void update(ErpSaleOrderDO updateSaleOrder, List<ErpSaleOrderItemDO> updateSaleOrderItems);
}